=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS) -Wall
CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

EXTRA_DH_ARGUMENTS =

# Sacrifice speed in order to make it more likely resource limits
# won't be hit.
ifeq ($(DEB_HOST_ARCH_BITS),32)
	LDFLAGS += -Wl,--no-keep-memory
endif

ifeq ($(DEB_BUILD_ARCH),alpha)
	LDFLAGS += -Wl,--no-relax
endif

# Disable debugging symbols on these arches.
ifneq (,$(filter $(DEB_BUILD_ARCH),hurd-i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc powerpcspe s390 s390x sparc armel armhf))
	CFLAGS := $(CFLAGS:-g=)
	EXTRA_DH_ARGUMENTS += -Nlibwebkit2gtk-4.0-37-dbg -Nlibjavascriptcoregtk-4.0-18-dbg
endif

# See https://bugs.webkit.org/show_bug.cgi?id=113638
ifeq (,$(filter $(DEB_BUILD_ARCH),i386 amd64 hurd-i386 kfreebsd-i386 kfreebsd-amd64 armhf))
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_JIT=OFF
	CPPFLAGS += -DENABLE_YARR_JIT=0 -DENABLE_ASSEMBLER=0
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	EXTRA_CMAKE_ARGUMENTS += -DUSE_SYSTEM_MALLOC=ON
endif

ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
	EXTRA_CMAKE_ARGUMENTS += -DCMAKE_BUILD_TYPE=Debug
else
	EXTRA_CMAKE_ARGUMENTS += -DCMAKE_BUILD_TYPE=Release
	CPPFLAGS += -DNDEBUG
endif

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	DEB_DH_GENCONTROL_ARGS += -- -Vgst:Recommends=""
else
	DEB_DH_GENCONTROL_ARGS += -- -Vgst:Recommends="gstreamer1.0-plugins-bad, gstreamer1.0-libav,"
endif

%:
	dh $@ --parallel $(EXTRA_DH_ARGUMENTS)

override_dh_auto_configure:
	slimit -m debian/jquery-1.9.1.js > \
	   Source/WebInspectorUI/Tools/PrettyPrinting/populate/jquery.min.js
	CFLAGS="$(CFLAGS) $(CPPFLAGS)" \
	CXXFLAGS="$(CFLAGS) $(CPPFLAGS)" \
	LDFLAGS="$(LDFLAGS)" \
	dh_auto_configure -- \
	   -DPORT=GTK \
	   -DCMAKE_INSTALL_LIBEXECDIR=lib/$(DEB_HOST_MULTIARCH) \
	   -DCMAKE_C_FLAGS_RELEASE="" \
	   -DCMAKE_C_FLAGS_DEBUG="" \
	   -DCMAKE_CXX_FLAGS_RELEASE="" \
	   -DCMAKE_CXX_FLAGS_DEBUG="" \
	   $(EXTRA_CMAKE_ARGUMENTS)

override_dh_strip:
	dh_strip -plibwebkit2gtk-4.0-37 --dbg-package=libwebkit2gtk-4.0-37-dbg $(EXTRA_DH_ARGUMENTS)
	dh_strip -plibjavascriptcoregtk-4.0-18 --dbg-package=libjavascriptcoregtk-4.0-18-dbg $(EXTRA_DH_ARGUMENTS)
	dh_strip $(EXTRA_DH_ARGUMENTS)

override_dh_makeshlibs:
	dh_makeshlibs -plibwebkit2gtk-4.0-37 -Xinjected-bundle $(EXTRA_DH_ARGUMENTS)
	dh_makeshlibs -plibjavascriptcoregtk-4.0-18 $(EXTRA_DH_ARGUMENTS)

override_dh_shlibdeps:
	dh_shlibdeps $(EXTRA_DH_ARGUMENTS)
	dh_girepository $(EXTRA_DH_ARGUMENTS)

override_dh_clean:
	dh_clean $(EXTRA_DH_ARGUMENTS)
	rm -f Source/WebInspectorUI/Tools/PrettyPrinting/populate/jquery.min.js

override_dh_auto_test:

VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p')
UPSTREAM_VERSION := $(shell echo $(VERSION) | sed 's/+dfsg1//')

get-orig-source:
	dh_testdir
	uscan --rename --download-current-version
	mkdir "webkit2gtk-$(VERSION)"
	tar -C "webkit2gtk-$(VERSION)" \
		--strip-components=1 \
		--exclude=Source/WebInspectorUI/Tools/PrettyPrinting/populate/jquery.min.js \
		--exclude=Tools/WebKitTestRunner/gtk/fonts/FontWithNoValidEncoding.fon \
		-xaf "../webkit2gtk_$(UPSTREAM_VERSION).orig.tar.xz"
	fakeroot tar -caf "../webkit2gtk_$(VERSION).orig.tar.xz" \
		"webkit2gtk-$(VERSION)"
	rm -rf "webkit2gtk-$(VERSION)"
